# -*- coding: utf-8 -*- 
from __future__ import unicode_literals

import uno

def createUnoService(service, ctx=None, args = None):
    smgr = uno.getComponentContext().ServiceManager
    if ctx and args:
        return smgr.createInstanceWithArgumentsAndContext(service, args, ctx)
    elif args:
        return smgr.createInstanceWithArguments(service, args)
    elif ctx:
        return smgr.createInstanceWithContext(service, ctx)
    else:
        return smgr.createInstance(service)

from com.sun.star.script.provider import ScriptFrameworkErrorException
def xray(obj):
    '''Macro to call Basic XRay by Bernard Marcelly from Python.'''
    ctx = uno.getComponentContext()
    url = ("vnd.sun.star.script:XRayTool._Main.Xray?"
           "language=Basic&location=application")
    mspf = createUnoService(
               "com.sun.star.script.provider.MasterScriptProviderFactory", ctx)
    try:
        script = mspf.createScriptProvider('').getScript(url)
        script.invoke((obj,), (), ())
    except ScriptFrameworkErrorException:
        msgbox('Xray is not installed.\nPlease visit:\n'
               'http://www.openoffice.org/fr/Documentation/Basic',
               'Error', 'error')

def mri(target):
    '''Macro to instantiate Mri introspection tool from hanya.'''
    ctx = uno.getComponentContext()
    mri = ctx.ServiceManager.createInstanceWithContext("mytools.Mri",ctx)
    try:
        mri.inspect(target)
    except AttributeError:
        msgbox('MRI is not installed.\nPlease visit:\n'
               'http://extensions.services.openoffice.org',
               'Error', 'error')

from com.sun.star.awt.MessageBoxType import (MESSAGEBOX, INFOBOX,
                                             ERRORBOX, WARNINGBOX, QUERYBOX)
def msgbox(message, titre="Message", boxtype='message', boutons=1, frame=None):
    types = {'message': MESSAGEBOX, 'info': INFOBOX, 'error': ERRORBOX,
             'warning': WARNINGBOX, 'query': QUERYBOX}
    ctx = uno.getComponentContext()
    tk = createUnoService("com.sun.star.awt.Toolkit", ctx)
    if not frame:
        desktop = createUnoService("com.sun.star.frame.Desktop", ctx)
        frame = desktop.ActiveFrame
    win = frame.ComponentWindow
    box = tk.createMessageBox(win, types[boxtype], boutons, titre, message)
    return box.execute()
